openapi: 3.0.0
info:
  title: Bet-Bro Api Public
  description: BET bro public API
  license:
    name: Apache-2.0
    url: https://www.apache.org/licenses/LICENSE-2.0
  version: V1
servers:


tags:
  - name: teams
    description: teams endpoints
  - name: championship
    description: championship endpoints


paths:
  /public/v1/teams:
    get:
      tags:
        - teams
      summary: Obtenir les équipes
      operationId: getTeams
      responses:
        200:
          description: équipe d'un championnat
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TeamsDescription'
        400:
          $ref: "#/components/requestBodies/Error"
        500:
          $ref: "#/components/requestBodies/Error"

    post:
      tags:
        - teams
      summary: Create a team
      operationId: createTeam
      requestBody:
        description: body
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateTeamRequest'
        required: true
      responses:
        200:
          description: Team created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TeamDescription'
        400:
          $ref: "#/components/requestBodies/Error"
        500:
          $ref: "#/components/requestBodies/Error"

  /public/v1/championships:
    get:
      tags:
        - championship
      summary: Obtenir les championnats
      operationId: getChampionships
      responses:
        200:
          description: obtenir les championnats
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ChampionshipsDescription'
        400:
          $ref: "#/components/requestBodies/Error"
        500:
          $ref: "#/components/requestBodies/Error"

  /public/v1/championships/teams:
    get:
      tags:
        - championship
      summary: Obtenir les championnats avec leurs équipes
      operationId: getTeamsChampionship
      responses:
        200:
          description: obtenir les championnats avec leurs équipes
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ChampionshipsTeamsDescription'
        400:
          $ref: "#/components/requestBodies/Error"
        500:
          $ref: "#/components/requestBodies/Error"


components:
  parameters:
    championship:
      name: championshipName
      in: path
      description: nom du championnat
      required: true
      schema:
        type: string
    teamName:
      name: teamName
      in: path
      description: nom de l'équipe
      required: true
      schema:
        type: string

  schemas:
    TeamDescription:
      type: object
      description: Description d'une équipe
      properties:
        championshipId:
          type: integer
          description: championship identifier
          format: int64
        acronym:
          type: string
          description: acronym
        fullName:
          type: string
          description: fullName
        creationDate:
          type: string
          format: date-time
          description: date of creation
          example: "2021-01-30T08:30:00Z"
      required:
        - acronym
        - fullName
        - creationDate

    ChampionshipDescription:
      type: object
      description: Description d'un championnat
      properties:
        championshipId:
          type: integer
          description: championship identifier
          format: int64
        countryName:
          type: string
          description: countryName
        leagueName:
          type: string
          description: leagueName
        teams:
          type: array
          description: les équipes du championnat
          items:
            $ref: '#/components/schemas/TeamDescription'
      required:
        - leagueName
        - countryName
        - creationDate

    ChampionshipsDescription:
      type: object
      description: Description des championnats
      properties:
        championships:
          type: array
          description: Les championnats
          items:
            $ref: '#/components/schemas/ChampionshipDescription'
      required:
        - championships

    ChampionshipsTeamsDescription:
      description: Description des championnats avec ses équipes
      properties:
        championships:
          type: object
          description: Les championnats
          additionalProperties:
            type: array
            items:
              $ref: '#/components/schemas/TeamDescription'


    TeamsDescription:
      type: array
      items:
        $ref: '#/components/schemas/TeamDescription'


    CreateTeamRequest:
      type: object
      description: Requête de création d'une équipe
      properties:
        championshipId:
          type: integer
          description: championship identifier
          format: int64
        acronym:
          type: string
        fullName:
          type: string
        creationDate:
          type: string
          format: date-time
      required:
        - acronym
        - fullName
        - creationDate
      example:
        acronym: "MUC72"
        fullName: "Le Mans Football Club"
        creationDate: 1885


